/**
/* $Id: utils.c,v 1.1 1998/02/13 08:56:15 falcon Exp $
/**/

#include "includes.h"

struct termios orcus_term;
struct termios saved_term;
extern int squelch_status;

/*  Paranoia is GOOD!  */
/*  Use scrub_free() instead of free().  It will write 0's to   */
/*  the data area before free()ing it.  The first parameter     */
/*  points to the data block being freed and the second is its  */
/*  length in bytes.  Security measure against garbage snoops.  */
void scrub_free ( p, n ) void *p; int n; {
  int i;
  for ( i = 0; i < n; i++ ) ((char*)p)[i] = 0;
  free ( (char*)p );
  }

void alstrcpy ( dest, src ) char **dest, *src; {
  int sz;
  sz    = strlen ( src ) + 1;
  *dest = (char*) malloc ( sz );
  strcpy ( *dest, src );
  }

char *nibble ( buf, n ) char *buf; int n; {
  int   x, i, j, k;
  int   beginning, ending;
  char *retval;

  k = strlen ( buf );
  for ( j = 0; ( j < k ) && ( buf[j] == ' ' ); j++ );
  if  ( j >= k ) return NULL;
  x = j;
  for ( i = 0; ( i < n ) && ( x < k ); i++ ) {
    while ( ( buf[x] != ' ' ) && ( x < k ) ) x++;
    while ( ( buf[x] == ' ' ) && ( x < k ) ) x++;
    }
  if ( x >= k ) return NULL;
  beginning = x;
  while ( ( buf[x] != ' ' ) && ( x < k ) ) x++;
  ending = x;
  retval = (char*) malloc ( ending - beginning + 1 );
  strncpy ( retval, buf + beginning, ending - beginning );
  retval[ending-beginning] = 0;
  return retval;
  }

char *gobble ( buf, n ) char *buf; int n; {
  int   x, i, j, k;
  int   beginning, ending;
  char *retval;

  k = strlen ( buf );
  for ( j = 0; ( j < k ) && ( buf[j] == ' ' ); j++ );
  if  ( j >= k ) return NULL;
  x = j;
  for ( i = 0; ( i < n ) && ( x < k ); i++ ) {
    while ( ( buf[x] != ' ' ) && ( x < k ) ) x++;
    while ( ( buf[x] == ' ' ) && ( x < k ) ) x++;
    }
  if ( x >= k ) return NULL;
  beginning = x;
  ending    = k;
  retval = (char*) malloc ( ending - beginning + 1 );
  strncpy ( retval, buf + beginning, ending - beginning );
  retval[ending-beginning] = 0;
  return retval;
  }

void nab_one ( buf, n, dest ) char *buf; int n; char *dest; {
  char *foo;
 
  extern int debug;
  extern char *bigbuf;

  if ( dest ) dest[0] = 0;
  foo = nibble ( buf, n );

  if( foo == NULL ) 
  { 
    if(debug)
      printf ("ARGH! 1\n"); 
    
    return;
  }

  if ( dest == NULL ) alstrcpy ( &bigbuf, foo );
  else strcpy ( dest, foo );
  scrub_free ( foo, strlen(foo) );
  }

void nab_rest ( buf, n, dest ) char *buf; int n; char *dest; {
  char *foo;
  extern int debug;
  extern char *bigbuf;

  if ( dest ) dest[0] = 0;
  foo = gobble ( buf, n );
  if( foo == NULL ) 
  {
    if(debug)
      printf ("ARGH! 2\n");
     
     return;
  }
  if ( dest == NULL ) alstrcpy ( &bigbuf, foo );
  else strcpy ( dest, foo );
  scrub_free ( foo, strlen(foo) );
  }

int snork_file ( f, buf ) FILE *f; char **buf; {
  int retval;
  fseek ( f, 0, SEEK_END );
  retval = ftell ( f );
  fseek ( f, 0, SEEK_SET );
  *buf = (char*) malloc ( retval + 1 );
  fread ( *buf, 1, retval, f );
  (*buf)[retval] = 0;
  return retval;
  }

void load_orcusrc ( s, fnameparam ) int s; char *fnameparam; {
  char fname[256];
  FILE *f;
  char *buf;
  int  i,j,k,finis;
  int  commandresult;
  /* zzapp -- fill this in later to use getenv and HOME */
  if   ( fnameparam == NULL ) strcpy ( fname, ".orcusrc" );
  else strcpy ( fname, fnameparam );
  f = fopen ( fname, "r" );
  if ( f == NULL ) {
    printf ("[=ORCUS=] cannot open '%s'\n",fname);
    return;
    }
  k = snork_file ( f, &buf );
  finis = 0;  i = 0;  j = 0;
  while ( !finis ) {
    while ( ( j < k ) && ( buf[j] != '\n' ) ) j++;
    if ( j >= k ) finis = 1; else {
      buf[j] = 0;
      if ( buf[i] ) if ( buf[i+1] ) {
         extern char *bigbuf;
         extern char  stuff[4][255];
         extern int  *confirm_quit;
         commandresult = analyze_input_string ( &(buf[i]) );
         switch ( commandresult ) {
            case NO_CMD:
                    break; /* No action required */
            case NOIDLE:
                    break; /* No action required */
            case HELP:
                    break; /* No action required */
            case SETDEBUG:
                    break; /* No action required */
            case CONFIRM:
                    break; /* No action required */
            case PUB_MSG:
                    writepub  ( s, bigbuf ); break;  /* in icb1io.c */
            case PRIVATE_MSG:
                    writepriv ( s, stuff[0], bigbuf ); break;  /* in icb1io.c */
            case DROP:
                    writecmd  ( s, stuff[0], stuff[1], stuff[2] ); break;  /* in icb1io.c !
            case ECHOBACK:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case WHO:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case NAME:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case NICK:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case BOOT:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case BEEP:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case PASSWD:
                    writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c */
            case READ:
                    writecmd  ( s, stuff[0], NULL, NULL ); break;  /* in icb1io.c */
            case CHANGE_GRP:
                    gotogroup ( s, stuff[0] ); break;  /* in icb1io.c */
            case TOPIC : writecmd  ( s, stuff[0], stuff[1], NULL ); break;  /* in icb1io.c!
            case PASS : passmod   ( s, stuff[0] ); break;  /* in icb1io.c */
            case WRITE:
                  writemail(s, stuff[0], bigbuf ); break;
            case QUIT: quit(confirm_quit); break;  /* in orcusutil.c */
            } /* END of switch */
         }
      i = j+1;
      }
    } /* finis */
  scrub_free ( buf, k );
  fclose ( f );
  } /* end of function load_orcusrc() */

int analyze_input_string ( buf ) /* puts parts into stuff[] */  
  char *buf;  { 
  char  foo[64];
  char *bar;
  int   i;
  extern int debug;
  extern char *bigbuf;
  extern char stuff[4][255];
  extern int noidle;
  extern int *confirm_quit;
  extern int bmessage;
  extern int breturn;
  extern int nobeep;
  extern int cols;
  extern int rows;
  extern int spat;
  extern int s;

  if(debug)
    printf ("analyze: alpha %d\n", (long) buf );

  if ( !buf[0] ) return NO_CMD;

  if(debug)
    printf ("analyze: beta\n");

  if ( bigbuf != NULL ) {
    if(debug)
      printf ("analyze: gamma\n");

    scrub_free ( bigbuf, strlen(bigbuf) );

    if(debug)
      printf ("analyze: delta\n");

    bigbuf = NULL;
    }

  if(debug)
    printf ("analyze: epsilon\n");
  if ( buf[1] != '/' ) if ( buf[0] == '/' ) {
    if(debug)
       printf ("analyze: iota\n");

    bar = nibble ( buf, 0 );
    if ( bar == NULL ) return NO_CMD;
    strcpy ( foo, bar );
    scrub_free ( bar, strlen(bar) );

    if ( !strcmp ( foo, "/m" ) ) {
        if(debug)
          printf ("analyze: iota-1, bigbuf is %u\n", (long) bigbuf );

        nab_one  ( buf, 1, stuff[0] );
        if(debug)
          printf ("analyze: iota-2, bigbuf is %u\n", (long) bigbuf );

        nab_rest ( buf, 2, bigbuf );
        return PRIVATE_MSG;
        }

    if (!strcmp(foo,"/write")){
       nab_one  ( buf, 1, stuff[0] );
       nab_rest ( buf, 2, bigbuf );
       return WRITE;
    }

    if (!strcmp(foo,"/read")){
       nab_one  ( buf, 1, stuff[0] );
       return READ;
    }

    if ( !strcmp ( foo, "/g" ) ) {
        nab_one ( buf, 1, stuff[0] );
        return CHANGE_GRP;
        }

    if ( !strcmp ( foo, "/echo" ) ) {
	strcpy( stuff[0], "echoback" );
	nab_one ( buf, 1, stuff[1] );
      return ECHO;
      }

    if ( ( !strcmp ( foo, "/who" ) ) ||
         ( !strcmp ( foo, "/w"   ) )    ) {
        stuff[0][0] = 'w';
        stuff[0][1] = 0;
        nab_one ( buf, 1, stuff[1] );
        return WHO;
        }

    if ( !strcmp ( foo, "/boot" ) ) {
        strcpy ( stuff[0], "boot" );
        nab_one ( buf, 1, stuff[1] );
        return BOOT;
        }

    if ( !strcmp ( foo, "/beep" ) ) {
        strcpy ( stuff[0], "beep" );
        nab_one ( buf, 1, stuff[1] );
        return BEEP;
        }

    if ( ( !strcmp ( foo, "/keepalive" ) ) ||
         ( !strcmp ( foo, "/noidle"    ) ) ||
         ( !strcmp ( foo, "/idle"      ) )    ) {
        nab_one ( buf, 1, stuff[1] );
        if ( stuff[1][0] ) {
          if ( !strcmp ( stuff[1], "on" ) ) noidle = 1;
          else noidle = 0;
          } else noidle = !noidle;
        if ( noidle ) 
          printf ("[=Idle=] keeping connection alive\n");
        else 
          printf ("[=Idle=] will let connection timeout\n");
        return NOIDLE;
        }

    if ( !strcmp ( foo, "/reload" ) ) {
      nab_rest ( buf, 1, stuff[1] );
      if ( stuff[1][0] ) load_orcusrc ( s, stuff[1] );
      else load_orcusrc ( NULL );
      return RELOAD;
      }

    if ( ( !strcmp ( foo, "/idlep" ) ) ||
         ( !strcmp ( foo, "/idleperiod" ) ) ) {
      extern int idleperiod;
      nab_one ( buf, 1, stuff[1] );
      idleperiod = 0;
      for ( i = 0; stuff[1][i]; i++ ) 
        idleperiod = ( idleperiod * 10 ) + ( stuff[1][i] - '0' );
      if ( idleperiod < 10 ) idleperiod = 10;
      printf ("[=Idle=] period set to %u seconds\n",idleperiod);
      return NO_CMD;
      } /* end of if idleperiod */

    if ( ( !strcmp ( foo, "/sq"      ) ) ||
         ( !strcmp ( foo, "/squelch" ) )    ) {
      extern lroot squelches;
      nab_one  ( buf, 1, stuff[1] );
      nab_rest ( buf, 2, stuff[2] );
      if ( !stuff[1][0] ) { 
         printf ("[=TYPO=] need argument\n"); 
         return NO_CMD; 
         }
      if ( !strcmp ( stuff[1], "on" ) ) {
        squelch_status = SQUELCH_PRIVATE | SQUELCH_OPEN;
        } else
      if ( !strcmp ( stuff[1], "off" ) ) {
        squelch_status = 0;
        } else
      if ( !strcmp ( stuff[1], "pub" ) ) {
        squelch_status = SQUELCH_OPEN;
        } else
      if ( !strcmp ( stuff[1], "pri" ) ) {
        squelch_status = SQUELCH_PRIVATE;
        } else
      if ( !strcmp ( stuff[1], "add" ) ) {
        strl *finger, *thumb;
        if ( !stuff[2][0] ) {
           printf ("[=TYPO=] needs second argument\n");
           return NO_CMD;
           }
        finger = squelches.t;
        if ( finger == NULL ) {
           squelches.h = (strl*)malloc(sizeof(strl));
           squelches.t = squelches.h;
           squelches.h->d = strdup ( stuff[2] );
           squelches.h->next = NULL;
           squelches.n = 1;
           } else {
           thumb = (strl*)malloc(sizeof(strl));
           thumb->d     = strdup ( stuff[2] );
           thumb->next  = NULL;
           finger->next = thumb;
           squelches.t  = thumb;
           squelches.n++;
           } /* end of if..else */
        } else /* end of "add" */
      if ( ( !strcmp ( stuff[1], "sub" ) ) ||
           ( !strcmp ( stuff[1], "rm"  ) )    ) {
        int   finis = 0;
        strl *finger, *thumb;
        if ( !stuff[2][0] ) {
           printf ("[=TYPO=] needs second argument\n");
           return NO_CMD;
           }
        if ( squelches.n == 0 ) {
          printf ("[=ERROR=] no items in squelch list to remove\n");
          return NO_CMD;
          }
        thumb  = NULL;
        finger = squelches.h; 
        while ( !finis ) {
          if ( !strcmp ( finger->d, stuff[2] ) ) {
            if ( squelches.n == 1 ) {
               squelches.n = 0;
               squelches.h = NULL;
               squelches.t = NULL;
               scrub_free ( finger->d, strlen(finger->d) );
               scrub_free ( finger, sizeof(strl) );
               } else {
               if ( thumb == NULL ) { /* first node in list */
                  squelches.h = finger->next;
                  squelches.n--;
                  scrub_free ( finger->d, strlen(finger->d) );
                  scrub_free ( finger, sizeof(strl) );
                  } else { /* not first node in list */
                  if ( finger->next == NULL ) { /* end of list */
                     thumb->next = NULL;
                     squelches.t = thumb;
                     scrub_free ( finger->d, strlen(finger->d) );
                     scrub_free ( finger, sizeof(strl) );
                     squelches.n--;
                     } else { /* not at end of list */
                     thumb->next = finger->next;
                     scrub_free ( finger->d, strlen(finger->d) );
                     scrub_free ( finger, sizeof(strl) );
                     squelches.n--;
                     } /* end of end of list check */
                  } /* end of not first node in list */
	       } /* end of if..else clause for n == 1 */
            finis = 1;
            } else { /* not a match */
            thumb  = finger;
            finger = finger->next;
            if ( finger == NULL ) finis = 1;
            } /* end of if..else */
          } /* end of while */ 
        } else /* end of "rm" */
      if ( !strcmp ( stuff[1], "nuke" ) ) {
        strl *finger, *thumb;
        squelches.n = 0;
        finger = squelches.h;
        while ( finger != NULL ) {
          thumb = finger->next;
          scrub_free ( finger->d, strlen(finger->d) );
          scrub_free ( finger, sizeof(strl) );
          finger = thumb;
          } /* end of while */
        squelches.h = NULL;
        squelches.t = NULL;
        printf ("[=ORCUS=] squelch list has been nuked\n");
        } else /* end of "nuke" */
      if ( !strcmp ( stuff[1], "list" ) ) {
        strl *finger;
        finger = squelches.h;
        if ( finger == NULL ) {
          printf ("[=ORCUS=] no strings in squelch list\n");
          return NO_CMD;
          }
        spat = 0;
        printf ("[=ORCUS=] squelching these strings:\n");
        spat ++;
        while ( finger != NULL ) {
          printf ("%s\n",finger->d);
          spat++;
          more_prompt();
          finger = finger->next;
          } /* end of while */
        printf ("[=ORCUS=] end of squelch list\n");
        } /* end of "list" */
      return NO_CMD;
      } /* end of if squelch */

    if ( ( !strcmp ( foo, "/v"       ) ) ||
         ( !strcmp ( foo, "/ver"     ) ) ||
         ( !strcmp ( foo, "/version" ) ) ) {
      printf ("[=ORCUS=] %s\n",ORCUS_VERSION);
      return NO_CMD;
      }

    if ( ( !strcmp ( foo, "/?" ) ) ||
         ( !strcmp ( foo, "/h" ) ) ||
         ( !strcmp ( foo, "/help" ) ) ) {
        printf ("/m       Send private message\n");
        printf ("/g       Go to a group\n");
        printf ("/w       List who is in the group\n");
        printf ("/boot    Boot someones ass outta there\n");
        printf ("/beep    Beep someone\n");
        printf ("/idle    Toggle noidle\n");
        printf ("/idlep   Set idle period to N seconds\n");
	printf ("/debug   Toggle verbose debug mode on or off\n");
        printf ("/drop    Drop an idle connection (yours)\n");
        printf ("/p       Set your password\n");
        printf ("/name    Set your name\n");
        printf ("/nick    Set your name\n");
        printf ("/notify  Be informed of when someones online\n");
        printf ("/topic   Set the topic\n"); 
        printf ("/bmsg    Toggle beep messages\n");
        printf ("/bret    Toggle beep return messages\n");
        printf ("/hush    Hush someone\n");
        printf ("/unhush  Unhush someone\n");
        printf ("/status  Change group status\n");
        printf ("/exclude Prevent a user from seeing your message\n");
        printf ("/nobeep  Toggle beeps\n");
        printf ("/pass    Pass the modship\n");
        printf ("/cols    Set display columns (0 for infinite)\n");
        printf ("/rows    Set display rows (0 for infinite)\n");
	printf ("/write nick message   write message\n");
	printf ("/read 	  read saved messages\n");
	printf ("/confirm ask if you want to quit\n");
	printf ("/time    display the time and date\n");
        printf ("/squelch squelch a substring from your display:\n");
        printf ("   on    Turn on  squelching\n");
        printf ("   off   Turn off squelching\n");
        printf ("   pub   Turn on  squelching for public  msgs only\n");
        printf ("   pri   Turn on  squelching for private msgs only\n");
        printf ("   add   Add a squelch string to the list\n");
        printf ("   sub   Remove a squelch string from the list\n");
        printf ("   rm    Remove a squelch string from the list\n");
        printf ("   nuke  Remove all squelch strings from the list\n");
        printf ("   list  List your squelch strings\n");
        printf ("/reload  Reload a config file\n");
        printf ("/ver     Show the version of this icb client\n");
        printf ("/q       Quit\n"); 
        return HELP;
        }

    if ( !strcmp ( foo, "/drop" ) ) {
        strcpy ( stuff[0], "drop" );
        nab_one ( buf, 1, stuff[1] );
        return DROP;
        }

    if ( !strcmp ( foo, "/time" ) ) {
        time_t thetime;
        thetime = time(NULL);
        printf ("%s",ctime(&thetime));
        return NO_CMD;
        }

    if(!strcmp(foo, "/debug")) /* realtime toggle of debug output */
    {
      if(!debug)
      {
        printf("[=DEBUG=] debug mode on!\n");
        debug = YES;
      }
      else 
      {
        printf("[=DEBUG=] debug mode off!\n");
        debug = NO; 
      }

      return NO_CMD;
    }

    if(!strcmp(foo, "/confirm")) /* toggle if quit asks or not */
    {
      if(!confirm_quit)
      {
        printf("[=Confirm=] You will now be asked if you want to quit.\n");
        confirm_quit = (int *) YES;
      }
      else
      {
        printf("[=Confirm=] You will no longer be asked if you want to quit.\n");
        confirm_quit = NO;
      }

    return NO_CMD;
    }

    if ( !strcmp ( foo, "/p" ) ) {
        strcpy ( stuff[0], "p" );
        nab_one ( buf, 1, stuff[1] );
        return PASSWD;
        }

    if ( !strcmp ( foo, "/name" ) ) {
        strcpy ( stuff[0], "name" );
        nab_one ( buf, 1, stuff[1] );
        return NAME;
        }

    if ( !strcmp ( foo, "/nick" ) ) {
        strcpy ( stuff[0], "name" );
        nab_one ( buf, 1, stuff[1] );
        return NICK;
        }

    if ( !strcmp ( foo, "/notify" ) ) {
        strcpy ( stuff[0], "notify" );
        nab_one ( buf, 1, stuff[1] );
        return NOTIFY;
        }

    if ( !strcmp ( foo, "/topic" ) ) {
        strcpy ( stuff[0], "topic" );
        nab_rest ( buf, 1, stuff[1] );
        return TOPIC;
        }

    if ( !strcmp ( foo, "/bmsg" ) ) {
        nab_one ( buf, 1, (char *) 1 );
        if ( !strcmp ( stuff[1], "on"  ) ) { 
           bmessage = 1; 
           printf ("[=Set=] /beep messages displayed when /nobeep is on\n");
           return NO_CMD; 
           }
        if ( !strcmp ( stuff[1], "off" ) ) {
           bmessage = 0; 
           printf ("[=Set=] /beep messages ignored when /nobeep is on\n");
           return NO_CMD; 
           }
        bmessage = !bmessage;
        if ( bmessage ) 
             printf ("[=Set=] /beep messages displayed when /nobeep is on\n");
        else printf ("[=Set=] /beep messages ignored when /nobeep is on\n");
        return NO_CMD;
        }

    if ( !strcmp ( foo, "/bret" ) ) {
        nab_one ( buf, 1, (char *) 1 );
        if ( !strcmp ( stuff[1], "on"  ) ) { 
           breturn = 1; 
           printf ("[=Set=] senders of ignored /beeps informed\n");
           return NO_CMD; 
           }
        if ( !strcmp ( stuff[1], "off" ) ) {
           breturn = 0; 
           printf ("[=Set=] senders of ignored /beeps remain unclued\n");
           return NO_CMD; 
           }
        breturn = !breturn;
        if ( breturn ) 
             printf ("[=Set=] senders of ignored /beeps informed\n");
        else printf ("[=Set=] senders of ignored /beeps remain unclued\n");
        return NO_CMD;
        }

    if ( !strcmp ( foo, "/hush" ) ) {
        printf ("[=Reminder=] tell the programmer to implement /hush\n");
        return HUSH;
        }

    if ( !strcmp ( foo, "/unhush" ) ) {
        printf ("[=Reminder=] tell the programmer to implement /unhush\n");
        return UNHUSH;
        }

    if ( !strcmp ( foo, "/status" ) ) {
        printf ("[=Reminder=] tell the programmer to implement /status\n");
        return STATUS;
        }

    if ( !strcmp ( foo, "/exclude" ) ) {
        strcpy ( stuff[0], "exclude" );
        nab_one  ( buf, 1, stuff[1] );
        nab_rest ( buf, 2, stuff[2] );
        return EXCLUDE;
        }

    if ( !strcmp ( foo, "/nobeep" ) ) {
        nab_one ( buf, 1, (char *) 1 );
        if ( !strcmp ( stuff[1], "on"  ) ) { 
           nobeep = 1; 
           printf ("[=Set=] nobeep is on\n");
           return NO_CMD; 
           }
        if ( !strcmp ( stuff[1], "off" ) ) {
           nobeep = 0; 
           printf ("[=Set=] nobeep is off\n");
           return NO_CMD; 
           }
        nobeep = !nobeep;
        if ( nobeep ) printf ("[=Set=] nobeep is on\n");
        else printf ("[=Set=] nobeep is off\n");
        return 0;
        }

    if ( !strcmp ( foo, "/pass" ) ) {
        nab_one ( buf, 1, stuff[0] );
        return PASS;
        }

    if ( !strcmp ( foo, "/cols" ) ) {
        stuff[0][0] = 0;
        nab_one ( buf, 1, stuff[0] );
        cols = 0;
        for ( i = 0; stuff[0][i]; i++ ) {
          cols *= 10;
          cols += stuff[0][i] - '0';
	  }
        if ( cols !=   0 ) if ( cols < 23 ) cols = 23;
        if ( cols >  240 ) cols = 0;
        printf ("[=Set=] columns set to %d\n", cols );
        return NO_CMD;
        }

    if ( !strcmp ( foo, "/rows" ) ) {
        stuff[0][0] = 0;
        nab_one ( buf, 1, stuff[0] );
        rows = 0;
        for ( i = 0; stuff[0][i]; i++ ) {
          rows *= 10;
          rows += stuff[0][i] - '0';
	  }
        if ( rows !=   0 ) if ( rows < 2 ) rows = 2;
        printf ("[=Set=] rows set to %d\n", rows );
        spat = 0;
        return NO_CMD;
        }

    if ( !strcmp ( foo, "/q" ) ) return QUIT;

    if ( buf[0] == '/' ) if ( buf[1] != '/' ) {
      printf ("[=TYPO=] command not found; try '/help'\n");
      return NO_CMD;
      }

    return NO_CMD;
    } /* end of if */

  if(debug)
    printf ("analyze: kappa\n");

  if ( buf[0] == '/' ) alstrcpy ( &bigbuf, buf+1 );
  else alstrcpy ( &bigbuf, buf );

  if(debug)
    printf ("analyze: lambda\n");

  return PUB_MSG;
  } /* end of function */

orc_mode_safe   ( pointer ) char *pointer; {}
orc_mode_unsafe ( pointer ) char *pointer; {}
orc_xmit_general ( s, buf ) int s; char *buf; {}
orc_xmit_private ( s, who, what ) int s; char *who, *what; {}
orc_vadd ( who, where ) char *who, *where; {}
orc_vsub ( who, where ) char *who, *where; {}
orc_vsave( which ) char *which; {}
orc_share_offer ( s, who ) int s; char *who; {}
orc_share_okay  ( s, who ) int s; char *who; {}
orc_share_not   ( s, who ) int s; char *who; {}

int quit(int *confirm_quit) 
{ 
  extern int debug;
 
  char quit_choice;

  if(debug)
    printf("confirm_quit is : %d\n", confirm_quit);

  if(confirm_quit)
  {
    printf("Are you sure you want to quit? (Y/n) ");
    quit_choice = toupper(getc(stdin));
    
    if(debug)
      printf("I got \"%c\"...\n", quit_choice);
   
    switch(quit_choice)
    {
      case 'Y'		: orc_quit();
      case '\n'		: orc_quit();
      default		: dont_quit(); 
    }
  }
  else
    orc_quit();
}

int orc_quit(void)
{
  extern char *chunkoram;
  extern int s;
  extern int debug;

  scrub_free ( chunkoram, REALLYHUGE );  /* free up alloced space. */
  printf("Connection closed.\n");
  close ( s );          /* Close up the socket */
  sttyinputreset();     /* reset the tty to blocking linemode */
  if ( debug ) printf ("[=Exiting=]\n"); 
  exit(0);	      /* and we quit */
  }

void dont_quit(void) /* don't quit and return to orcus */
{
  printf("\n"); /* to make it look pretty after you say no */
  return;
}

int sttyinputset(void)
{
  extern int debug;
  /* Make sure we have stdin */
  if(isatty(STDIN_FILENO) == 0)
  {
    if(debug)
      perror("stdin is not a terminal device");
    return(1);
  }

  if(tcgetattr(STDIN_FILENO, &orcus_term) < 0)
  {
    if(debug)
      perror("tcgetattr error");
    return(1);
  }

  /* make a copy of the term settings and store them away */
  memcpy (&saved_term, &orcus_term, sizeof(orcus_term));

#if defined SYSV || defined __OpenBSD__ 

 orcus_term.c_lflag &= ~(ECHO);
 orcus_term.c_lflag &= ~(ICANON);
 orcus_term.c_cc[VTIME] = 0;
 orcus_term.c_cc[VEOF]  = 1;
 tcsetattr(STDIN_FILENO, TCSAFLUSH, &orcus_term );

#else /* BSD */
 orcus_term.sg_flags |=  (CBREAK);
 orcus_term.sg_flags &= ~(ECHO);

#endif
}

int sttyinputreset(void) 
{
  extern int debug;

  if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &saved_term) < 0)
  {
    if(debug)
      perror("tcgetattr error");
    return(1);
  }
}

/** Function fdpoll **/

int fdpoll(fd)

int fd; 

{
  int retval;
  ioctl ( fd, FIONREAD, &retval );
  return retval;
}

/** end of function fdpoll **/
